# Working 09-08-2020
from pymodbus.client.sync import ModbusTcpClient
import socket
import time

def is_open(ip,port):
    s = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
    # 1 second timeout
    s.settimeout(1)
    
    try:
        s.connect((ip, int(port)))
        s.shutdown(socket.SHUT_WR)
        return True
    except:
        return False
    finally:
        s.close()

def check_host(host, retry, delay):
    isup = False
    for i in range(retry):
        if is_open(host,502):
            isup = True
            break
        else:
            print("PLC not running retry " + str(i+1))
            time.sleep(1)
    return isup
    
# value must be passed as a list
def write_data(address, value, client):
    # Write data
    if address < 400001:
        address -= 1
        client.write_coil(address, value)
    else:
        address -= 400001
        client.write_register(address, value)
        
def read_data(address, amount, client):
    # Read data
    values = None
    if address < 400001:
        address -= 1
        response = client.read_coils(address, amount)
        values = response.bits[0:amount]
    else:
        address -= 400001
        response = client.read_holding_registers(address, amount)
        values = response.registers[0:amount]
    return values   